module Ruport::Bench
  
  require "benchmark"  

  def bench_case(name,n,&block)
    2.times { 
      @run = 0
      n.times do
        @bench_prepare.call if @bench_prepare
        @run += Benchmark.realtime { block.call } 
      end
    }     
    @bench_results << { "name" => name, "iterations" => n, 
                        "realtime" => (time = sprintf("%.5f",@run)) } 
    STDERR.puts "> #{name}... ok[#{time}] "
    @bench_prepare = nil
  end      

  def bench_prepare(&block)
    @bench_prepare = block
  end
  
  def bench_suite(&block)
    STDERR.puts "Running Bench Suite..."
    @bench_results = Table(%w[name iterations realtime]) 
    block.call   
    puts @bench_results   
    puts "Suite run time: " << sprintf("%.5f",@bench_results.sigma("realtime"))
  end  
  
end
