module Ruport
  class ReportManager  

    def self.add_model(*new_models)
       self.models |= new_models
    end   
    
    def self.add_report(*new_reports)
      self.reports |= new_reports
    end
               
    # Looks in reports first, then models.
    # if there is a conflict, you are F'ed.
    #
    # just kidding, use models#find or reports#find
    def self.[](name)     
      reports.find { |r| r.name.eql?(name) } ||
      models.find { |m| m.name.eql?(name) }
    end
  
    def self.models
      @models ||= []
    end      
    
    def self.reports
      @reports ||= []
    end
  
    class << self
      attr_writer :models 
      attr_writer :reports 
    end
  
  end          
end

if defined? ActiveRecord
  class ActiveRecord::Base
    def self.acts_as_managed_report
      Ruport::ReportManager.add_model(self)
    end     
  end
end          

class Ruport::Report
  def self.acts_as_managed_report
    Ruport::ReportManager.add_report(self)
  end
end

if __FILE__ == $PROGRAM_NAME                        
  
  include Ruport     
  
  require "test/unit"
  
  # we'll autoregister this one  
  class FakeModel
    ReportManager.add_model(self)
  end                          
  
  # we'll add these afterwards
  class FakeModel2;end
  class FakeModel3;end
  
  
  class TestReportManager < Test::Unit::TestCase     
     
     def test_simple_usage
        assert_equal [FakeModel], ReportManager.models
        assert_equal FakeModel, ReportManager["FakeModel"]
     end         
     
     def test_add_models_externally
        klass = ReportManager.dup # we need to do this to make the tests work 
                                  # no need in production code
        assert_equal [FakeModel], klass.models        
        
        klass.add_model(FakeModel2)
        assert_equal [FakeModel,FakeModel2], klass.models
        
        klass.add_model(FakeModel3)
        assert_equal [FakeModel,FakeModel2, FakeModel3], klass.models
        
        # let's make sure we can still grab these by name (a string)
        [FakeModel,FakeModel2,FakeModel3].each do |m|  
          assert_equal m, klass[m.name]
        end
     end 
     
  end
end
  
