require "test/init"
require "ruport/util/invoice"

class TestInvoice < Test::Unit::TestCase

  def test_required_options         
    assert_raises(Ruport::Renderer::RequiredOptionNotSet) { 
      Ruport::Renderer::Invoice.render_pdf 
    }
    
    #hash form
    assert_nothing_raised {
      Ruport::Renderer::Invoice.render_pdf :data => Table(%w[a b c]) << [1,2,3],
         :customer_info => "blah", :company_info => "also blah",
         :order_info => "Incredibly Blah", :comments => "Super Blah"
    }         
    
    #block form
    assert_nothing_raised {
      Ruport::Renderer::Invoice.render_pdf do |r|
         r.data = Table(%w[a b c]) << [1,2,3]
         r.customer_info = "blah"
         r.company_info  = "also blah"
         r.order_info    = "Incredibly Blah"  
         r.comments      = "Super blah"
      end     
    }
  end
  
  
end  
