require "test/init"
require "ruport/util/report_manager"
   
class Sample < Ruport::Report; def generate; "Hello Mike"; end; end
class Sample2 < Ruport::Report; def generate; "Hello Joe"; end; end
Sample.acts_as_managed_report
Sample2.acts_as_managed_report  

class FakeModel2;end
class FakeModel3;end

class TestReportManager < Test::Unit::TestCase
   
  def test_simple_usage  
    assert_equal "Hello Mike", Ruport::ReportManager["Sample"].run
    assert_equal "Hello Joe", Ruport::ReportManager["Sample2"].run 
    assert_equal [ Sample, Sample2 ], Ruport::ReportManager.reports       
  end   
               
  def test_add_models
    # we need to do this to make the tests work,no need in production code
    klass = Ruport::ReportManager.dup 

    assert_equal [], klass.models        

    klass.add_model(FakeModel2)
    assert_equal [FakeModel2], klass.models

    klass.add_model(FakeModel3)
    assert_equal [FakeModel2, FakeModel3], klass.models

    # let's make sure we can still grab these by name (a string)
    [FakeModel2,FakeModel3].each do |m|  
      assert_equal m, klass[m.name]
    end
  end  
  
end